/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */
/*
	Keyboard i/o test program
*/

/* standard includes */
#include <stdlib.h> 
#include <stdio.h>
#include <string.h>
#include "socket.h"

/* fixups for HI-TECH C, GCC, and probably other compilers. */
#ifdef HI_TECH_C
#include <sys.h>
#include <unixio.h>
#include <conio.h>
#include <stat.h>
#include <cpm.h>
#else
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#ifdef LINUX
#include <asm/io.h>
#endif
#endif

#include "in.h"
#include "netinet.h"
#include <ctype.h>

/* various fixups, os dependent */
#include "compat.h"
#include "netutil.h"

#define PROGRAM "TSTKEY"
#define VERSION "0.0.0"
#define EXECUTABLE "TSTKEY"

char *keyboard;
char *cmdq;
int depth;

/* buffered keystrokes */
void dokeyin(VOIDFIX)
{
	int key;

	if(depth < 126) {
		if(fixkbhit()) {
			key = fixgetch();
			keyboard[depth] = key & 0xff;
			depth++;
		}
	}	
}



char keystroke(VOIDFIX)
{

	char c;
	
	while(!depth) {
		dokeyin();
	}

	c = *keyboard;
	depth--;
	memmove(keyboard, keyboard + 1, depth);
	return(c);
}

void doconin(quiet)
int quiet;
{
	int i;
	int j;
	int cr;
	char key;
	
	i = j = cr = 0;
	cmdq[0] = 0x00;


	while(!cr) {
		key = keystroke();
		printf("%2.2x ", key & 0xff);
		if((key == 0x08) || (key == 0x7f)) {
			if(i > 0) {
				i--;
				if(!quiet) printf("\b \b");
				fflush(stdout);
			}
		} else {
			if((key == 0x0d) || (key == 0x0a)) {
				cr = 1;
			} else {
				if(i < 126) {
					cmdq[i] = key & 0xff;
					i++;
					if(!quiet) putchar(key);
					fflush(stdout);
				}
			}
		}
	}
	cmdq[i] = 0x00;
	/* whew, we now have the data! */
	putchar('\n');
}


int main(argc, argv)
int argc;
char *argv[];
{

	keyboard = safemalloc(10);
	cmdq = safemalloc(160);
	depth = 0;
	
	printf("echo keys :");
	doconin(0);
	printf("\nNo echo :");
	doconin(1);
	printf("\n");
	return(0);
}

/* tell link parser who we are and where we belong


*/
